package xyz.lychee.lagfixer.libs.adventure.text.format;

import java.util.Iterator;
import java.util.Map;
import java.util.Objects;
import java.util.Set;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.ApiStatus.NonExtendable;

@NonExtendable
public interface MutableStyleSetter<T extends MutableStyleSetter<?>> extends StyleSetter<T> {
   @Contract("_ -> this")
   default @NotNull T decorate(final @NotNull TextDecoration... decorations) {
      int i = 0;

      for(int length = decorations.length; i < length; ++i) {
         this.decorate((TextDecoration)decorations[i]);
      }

      return this;
   }

   @Contract("_ -> this")
   default @NotNull T decorations(final @NotNull Map<TextDecoration, TextDecoration.State> decorations) {
      Objects.requireNonNull(decorations, "decorations");
      Iterator var2 = decorations.entrySet().iterator();

      while(var2.hasNext()) {
         Map.Entry<TextDecoration, TextDecoration.State> entry = (Map.Entry)var2.next();
         this.decoration((TextDecoration)entry.getKey(), (TextDecoration.State)entry.getValue());
      }

      return this;
   }

   @Contract("_, _ -> this")
   default @NotNull T decorations(final @NotNull Set<TextDecoration> decorations, final boolean flag) {
      TextDecoration.State state = TextDecoration.State.byBoolean(flag);
      decorations.forEach((decoration) -> {
         this.decoration(decoration, state);
      });
      return this;
   }
}
